// ESP_Wemos
// attend x seconde , poste en mqtt , deep sleep
// https://github.com/claws/BH1750 lumiere
// https://github.com/wemos/LOLIN_HP303B_Library pression temp
// https://github.com/fu-hsi/pms PMS5003 particules fines
// https://github.com/lewapek/sds-dust-sensors-arduino-library
// MQ-07
// https://github.com/tzapu/WiFiManager
// https://github.com/bblanchon/ArduinoJson
// https://github.com/kosme/arduinoFFT, in IDE, Sketch, Include Library, Manage Library, then search for FFT

// message MQTT
//nom_du_capteur/valeur
// jeff/temperature
// jeff/humidite
// jeff/pression
// jeff/lumiere
// jeff/mq-135/gaz1
// jeff/pm_1
// jeff/pm_2_5
// jeff/pm_10
// jeff/pm_endessous_0_3
// jeff/pm_endessous_0_5
// jeff/pm_endessous_1
// jeff/pm_endessous_2_5
// jeff/pm_endessous_5
// jeff/pm_endessous_10
// //jeff/sons
//
#define SDS011  //SDS011 Nova sensor else PMS5003
//#define SHT_30
//#define BH_1750
//#define HP_303B
//#define MQ
#define FFT_ON  // calcul FFT

#include <FS.h>
#include <ESP8266WiFi.h>
#include <DNSServer.h>
#include <Wire.h>
#include <WEMOS_SHT3X.h>
#include <LOLIN_HP303B.h>
#include <BH1750.h>

#ifdef SDS011
#include "SdsDustSensor.h"
int rxPin = D3; // sds011 D1 D2 utilisé par DHT12 i2c
int txPin = D4;
SdsDustSensor sds(rxPin, txPin);
#else
#include <pms.h>
Pmsx003 pms(D4, D3);
#endif
#ifdef FFT_ON
#include "arduinoFFT.h" // Standard Arduino FFT library
arduinoFFT FFT = arduinoFFT();
#define SAMPLES 256              //Must be a power of 2
#define SAMPLING_FREQUENCY 10000 //Hz, must be 10000 or less due to ADC conversion time. Determines maximum frequency that can be analysed by the FFT.
#define amplitude 50
unsigned int sampling_period_us;
unsigned long microseconds;
byte peak[] = {0, 0, 0, 0, 0, 0, 0};
double vReal[SAMPLES];
double vImag[SAMPLES];
unsigned long newTime, oldTime;
#endif
#include <Ticker.h>
#include "EspMQTTClient.h"
Ticker ticker;
Ticker ticker2;
#ifdef SHT_30
SHT3X sht30(0x45);
#endif
#ifdef BH_1750
BH1750 lightMeter(0x23);
#endif
#ifdef HP_303B
LOLIN_HP303B HP303BPressureSensor = LOLIN_HP303B();
#endif
const int PIN_ON = D5; // Pin power on
const int GAZ1_A0 = A0;
//#define DEBUG

//// WifiManager_UI variables
char mqtt_server[40]             = "url du serveur.........................";
char mqtt_server_defaut[40]      = "url_serveur";
char mqtt_port[6]                = "1883";
char mqtt_port_defaut[6]         = "1883";
char client_mqtt[20]             = "nom du capteur....";
char client_mqtt_defaut[20]      = "nom_du_capteur";
char user_mqtt[20]               = "utilisateur.......";
char user_mqtt_defaut[20]        = "utilisateur";
char user_pass[20]               = "mot de passe......";
char user_pass_defaut[20]        = "mot_de_passe";
/////////////////////////////////// valeurs du msq MQTT

bool envoie_mqtt = false;
bool connexion_prette = false;

float temps_milli            = 24000;   // temps milli entre 2 mesures
uint64_t minute_dodo       = 10; // min  ESP.deepSleep(1000000 * 60 * (uint64_t)min);
float temps_ecoute_son = 600000;  // en milli 60*1000*minutes

float frequence = 0;  //temps_milli; frequence des mesures, delai
int retour_ok = 0;    // retour du serveur
float temperature = 0;   // temp HP303B
float temperatre = 0; // temp SHT30
float humidite = 0;
float pression = 0;
float lumiere = 0;
float gaz1 = 0;
float pm_1 = 0;
float pm_2_5 = 0;
float pm_10 = 0;
float pm_1_std = 0;
float pm_2_5_std = 0;
float pm_10_std = 0;
float pm_endessous_0_3 = 0;
float pm_endessous_0_5 = 0;
float pm_endessous_1   = 0;
float pm_endessous_2_5 = 0;
float pm_endessous_5   = 0;
float pm_endessous_10  = 0;
auto lastRead = millis();
float fft_125 = 0;
float fft_250 = 0;
float fft_500 = 0;
float fft_1000 = 0;
float fft_2000 = 0;
float fft_4000 = 0;
float fft_8000 = 0;
float pic_fft_125 = 0;
float pic_fft_250 = 0;
float pic_fft_500 = 0;
float pic_fft_1000 = 0;
float pic_fft_2000 = 0;
float pic_fft_4000 = 0;
float pic_fft_8000 = 0;
float moy_fft_125 = 0;
float moy_fft_250 = 0;
float moy_fft_500 = 0;
float moy_fft_1000 = 0;
float moy_fft_2000 = 0;
float moy_fft_4000 = 0;
float moy_fft_8000 = 0;
long periode = 0 ; // nbr de SAMPLE
long boucle = 200 ;
void tick() {
  //toggle state
  int state = digitalRead(LED_BUILTIN);
  digitalWrite(LED_BUILTIN, !state);
}
void clignotte() {
  int state = digitalRead(LED_BUILTIN);
  digitalWrite(LED_BUILTIN, !state);
  digitalWrite(LED_BUILTIN, state);
  digitalWrite(LED_BUILTIN, !state);
  digitalWrite(LED_BUILTIN, state);
}

void setup() {
  // Connect D0 to RST to wake up
  pinMode(D0, WAKEUP_PULLUP);
  Serial.begin(115200);
  pinMode(LED_BUILTIN, OUTPUT);

  pinMode(PIN_ON, OUTPUT);
  digitalWrite(PIN_ON, HIGH); // sensor ON

  ticker.attach(0.6, tick);
  Serial.println(ESP.getChipId(), HEX);
  pinMode(GAZ1_A0, INPUT);
  WifiManager_UI();
  ticker.detach();
  ticker.attach(2, tick);
  /////////////// CAPTEURS ////////////////
  Serial.println();
  Wire.begin();
  delay(200);
  Serial.println("");
  //Serial.println(WiFi.ssid);
  Serial.println("IP addresse: ");
  IPAddress IPLOCAL = WiFi.localIP();
  Serial.println("hostname: ");
  Serial.println(WiFi.hostname());
#ifdef HP_303B
  HP303BPressureSensor.begin();
  delay(200);
#endif
#ifdef BH_1750
  // BH1750
  if (!lightMeter.begin(BH1750::ONE_TIME_HIGH_RES_MODE)) Serial.println(F("Error initialising BH1750"));
  //
  delay(200);
#endif

  ////SDS010
#ifdef SDS011

  sds.begin();
  Serial.println(sds.queryFirmwareVersion().toString()); // prints firmware version
  Serial.println(sds.setQueryReportingMode().toString()); // ensures sensor is in 'query' reporting mode

  //Serial.println(sds.setActiveReportingMode().toString()); // ensures sensor is in 'active' reporting mode
  //Serial.println(sds.setCustomWorkingPeriod(1).toString()); // sensor sends data every 1 minutes
#else
  //// PMS5003 ////
  pms.begin();
  pms.write(Pmsx003::cmdModeActive);  // par defaut mode passive
  pms.write(Pmsx003::cmdSleep);
  pms.write(Pmsx003::cmdWakeup);
#endif
#ifdef FFT_ON
  sampling_period_us = round(1000000 * (1.0 / SAMPLING_FREQUENCY));
#endif
  delay(1000);
}
void onConnectionEstablished() {
  connexion_prette = true ;
  Serial.println("connexion prette");
}

void loop() {
  envoie_mqtt = false;
  frequence = minute_dodo;
#ifdef BH_1750
  //// BH1750   /////
  uint16_t lux = lightMeter.readLightLevel();
  lumiere  = (float) lux;
  Serial.print("BH1750 Lumiere: ");
  Serial.print(lumiere);
  Serial.println(" lx");
#endif
#ifdef HP_303B
  ////  HP303B  /////
  int16_t oversampling = 7;
  int16_t ret;
  int32_t ret_temperature;
  int32_t ret_pression;
  //ret = HP303BPressureSensor.measureTempOnce(temperature);
  //the commented line below does exactly the same as the one above, but you can also config the precision
  //oversampling can be a value from 0 to 7
  //the HP303B will perform 2^oversampling internal temperature measurements and combine them to one result with higher precision
  //measurements with higher precision take more time, consult datasheet for more information
  ret = HP303BPressureSensor.measureTempOnce(ret_temperature, oversampling);
  if (ret != 0)
  {
    Serial.print("FAIL! ret = ");
    Serial.println(ret);
  }
  else
  {
    Serial.print("HP303B Temperature: ");
    temperature = (float) ret_temperature;
    Serial.print(temperature);
    Serial.println(" degres");
  }
  //Pressure measurement behaves like temperature measurement
  //ret = HP303BPressureSensor.measurePressureOnce(pressure);
  ret = HP303BPressureSensor.measurePressureOnce(ret_pression, oversampling);
  if (ret != 0)
  {
    Serial.print("FAIL! ret = ");
    Serial.println(ret);
  }
  else
  {
    Serial.print("HP303B Pression: ");
    pression = (float) ret_pression;
    Serial.print(pression);
    Serial.println(" Pascal");
  }
#endif
#ifdef SHT_30
  //// SHT30 /////
  if (sht30.get() == 0) {
    temperatre = (float)sht30.cTemp;
    humidite   = (float)sht30.humidity;
    Serial.print("SHT30 Temperature       : ");
    Serial.println(temperatre);
    Serial.print("SHT30 Humidite relative : ");
    Serial.println(humidite);
  }
#endif
  //// MQ-135 ////
  //Serial.println("attend 30s pour chauffe MQ");
  //Serial.print("GAZ MQ 07        : ");
  //delay(30000);
  gaz1 = (float)analogRead(GAZ1_A0);
  Serial.println(gaz1);
#ifdef SDS011
  sds.wakeup();
  delay(30000); // working 30 seconds

  PmResult pm = sds.queryPm();
  if (pm.isOk()) {
    Serial.print("PM2.5 = ");
    Serial.print(pm.pm25);
    Serial.print(", PM10 = ");
    Serial.println(pm.pm10);
    pm_1   = 0;
    pm_2_5 = (float) pm.pm25;
    pm_10  = (float) pm.pm10;
    envoie_mqtt = true;
  } else {
    Serial.print("Could not read values from sensor, reason: ");
    Serial.println(pm.statusToString());
  }
#else
  //// PMS5003 ////
  pms.write(Pmsx003::cmdWakeup);
  float pm_1_tot = 0;
  float pm_2_5_tot = 0;
  float pm_10_tot = 0;
  Serial.print("attend s ");
  Serial.println (temps_milli / 1000);
  delay(temps_milli);

  int bonne_mesure = 0;
  for (bonne_mesure = 0; bonne_mesure <= 4; ) { //fait 4 mesures et prend la moyenne des positifs
    pms.waitForData(Pmsx003::wakeupTime);

    for (int i = 0; i <= 10; i++ ) {
      pm_1_std   = 0;
      pm_2_5_std = 0;
      pm_10_std  = 0;
      pm_1   =  0;
      pm_2_5 =  0;
      pm_10  =  0;
      pm_endessous_0_3 =  0;
      pm_endessous_0_5 =  0;
      pm_endessous_1   = 0;
      pm_endessous_2_5 =  0;
      pm_endessous_5   =  0;
      pm_endessous_10  =  0;
      const auto n = Pmsx003::Reserved;
      Pmsx003::pmsData data[n];
      Pmsx003::PmsStatus status = pms.read(data, n);
      switch (status) {
        case Pmsx003::OK:
          {
            bonne_mesure++;
            Serial.println(bonne_mesure);
            auto newRead = millis();
            lastRead = newRead;
            Serial.println(newRead - lastRead);
            lastRead = newRead;
            // For loop starts from 3
            // Skip the first three data (PM1dot0CF1, PM2dot5CF1, PM10CF1)
            for (size_t i = Pmsx003::PM1dot0; i < n; ++i) {
              Serial.print(data[i]);
              Serial.print("\t");
              Serial.print(Pmsx003::dataNames[i]);
              Serial.print(" [");
              Serial.print(Pmsx003::metrics[i]);
              Serial.print("]");
              Serial.println();
            }
            pm_1_std   = (float)data[3];
            pm_2_5_std = (float)data[4];
            pm_10_std  = (float)data[5];
            pm_1   = (float)data[3];
            pm_2_5 = (float)data[4];
            pm_10  = (float)data[5];
            pm_1_tot   += pm_1;
            pm_2_5_tot += pm_2_5;
            pm_10_tot  += pm_10;
            pm_endessous_0_3 = (float)data[6];
            pm_endessous_0_5 = (float)data[7];
            pm_endessous_1   = (float)data[8];
            pm_endessous_2_5 = (float)data[9];
            pm_endessous_5   = (float)data[10];
            pm_endessous_10  = (float)data[11];
            if ( bonne_mesure++ > 1) {// 2 premieres bonnes mesures non prises en compte
              pm_1_tot   += pm_1;
              pm_2_5_tot += pm_2_5;
              pm_10_tot  += pm_10;
              envoie_mqtt = true;
            }
            break;
          }
        case Pmsx003::noData:
          Serial.println("attend pms");
          break;
        default:
          Serial.println("_________________");
          Serial.println(Pmsx003::errorMsg[status]);
      }
      if (envoie_mqtt) break;
    }
    if (bonne_mesure == 1) delay(4000);
    delay(1000) ;
  }
  // on garde les moyennes des bons apres la premiere mesure
  pm_1   = pm_1_tot   / 3;
  pm_2_5 = pm_2_5_tot / 3;
  pm_10  = pm_10_tot  / 3;
#endif
#ifdef FFT_ON
  // on analyse le son sur le reste du temps de la boulce
  moy_fft_125 = 0;
  moy_fft_250 = 0;
  moy_fft_500 = 0;
  moy_fft_1000 = 0;
  moy_fft_2000 = 0;
  moy_fft_4000 = 0;
  moy_fft_8000 = 0;
  pic_fft_125 = 0;
  pic_fft_250 = 0;
  pic_fft_500 = 0;
  pic_fft_1000 = 0;
  pic_fft_2000 = 0;
  pic_fft_4000 = 0;
  pic_fft_8000 = 0;
  int lecture_valide = 0;
  float temps_debut = millis();
  while ( millis() - temps_debut < temps_ecoute_son) {
    fft_125 = 0;
    fft_250 = 0;
    fft_500 = 0;
    fft_1000 = 0;
    fft_2000 = 0;
    fft_4000 = 0;
    fft_8000 = 0;

    periode = 0;
    for (int i = 0; i < SAMPLES; i++) {
      newTime = micros() - oldTime;
      oldTime = newTime;
      vReal[i] = analogRead(A0); // A conversion takes about 1mS on an ESP8266
      vImag[i] = 0;
      while (micros() < (newTime + sampling_period_us)) {
        /* do nothing to wait */
      }
    }
    FFT.Windowing(vReal, SAMPLES, FFT_WIN_TYP_HAMMING, FFT_FORWARD);
    FFT.Compute(vReal, vImag, SAMPLES, FFT_FORWARD);
    FFT.ComplexToMagnitude(vReal, vImag, SAMPLES);

    for (int i = 2; i < (SAMPLES / 2); i++) { // Don't use sample 0 and only first SAMPLES/2 are usable. Each array eleement represents a frequency and its value the amplitude.
      if (vReal[i] > 100) { // Add a crude noise filter, 4 x amplitude or more
        lecture_valide += 1; // bonne lecture
        if (i <= 5 )              fft_125  = (float)( (int)vReal[i] / amplitude); // 125Hz
        if (i > 5   && i <= 12 )  fft_250  = (float)( (int)vReal[i] / amplitude); // 250Hz
        if (i > 12  && i <= 32 )  fft_500  = (float)( (int)vReal[i] / amplitude); // 500Hz
        if (i > 32  && i <= 62 )  fft_1000 = (float)( (int)vReal[i] / amplitude); // 1000Hz
        if (i > 62  && i <= 105 ) fft_2000 = (float)( (int)vReal[i] / amplitude); // 2000Hz
        if (i > 105 && i <= 120 ) fft_4000 = (float)( (int)vReal[i] / amplitude); // 4000Hz
        if (i > 120 && i <= 146 ) fft_8000 = (float)( (int)vReal[i] / amplitude); // 8000Hz

        if (fft_125 > pic_fft_125) pic_fft_125 = fft_125;
        moy_fft_125 += fft_125;
        if (fft_250 > pic_fft_250) pic_fft_250 = fft_250;
        moy_fft_250 += fft_250;
        if (fft_500 > pic_fft_500) pic_fft_500 = fft_500;
        moy_fft_500 += fft_500;
        if (fft_1000 > pic_fft_1000) pic_fft_1000 = fft_1000;
        moy_fft_1000 += fft_1000;
        if (fft_2000 > pic_fft_2000) pic_fft_2000 = fft_2000;
        moy_fft_2000 += fft_2000;
        if (fft_4000 > pic_fft_4000) pic_fft_4000 = fft_4000;
        moy_fft_4000 += fft_4000;
        if (fft_8000 > pic_fft_8000) pic_fft_8000 = fft_8000;
        moy_fft_8000 += fft_8000;
      }
    }
  }
  moy_fft_125 = moy_fft_125 / lecture_valide;
  moy_fft_250 = moy_fft_250 / lecture_valide;
  moy_fft_500 = moy_fft_500 / lecture_valide;
  moy_fft_1000 = moy_fft_1000 / lecture_valide;
  moy_fft_2000 = moy_fft_2000 / lecture_valide;
  moy_fft_4000 = moy_fft_4000 / lecture_valide;
  moy_fft_8000 = moy_fft_8000 / lecture_valide;

#endif
  ///////// MQTT config  ////////////
  if (envoie_mqtt == true) {
    Serial.print(mqtt_server);
    Serial.print(" ");
    Serial.print(mqtt_port);
    Serial.print(" ");
    Serial.print(client_mqtt);
    Serial.print(" ");
    Serial.print(user_pass);
    Serial.print(" ");
    Serial.println(user_mqtt);
    EspMQTTClient client(NULL, NULL, mqtt_server, user_mqtt, user_pass, client_mqtt, atoi(mqtt_port));
    client.enableDebuggingMessages(); // Enable debugging messages sent to serial output

    client.loop();
    if (connexion_prette == true ) {
      if (pression > 0) pression = pression / 100 ; // pascal vers millibars
      Serial.println("publie");
      // Publish a message to "mytopic/test"
      client.publish(strcat (client_mqtt , "/frequence"),  String(frequence).c_str(), true);
#ifdef HP_303B
      if (temperature > 0) client.publish(strcat (client_mqtt , "/HP303B/temperature"), (temperature).c_str(), true);
      if (pression > 0)    client.publish(strcat (client_mqtt , "/HP303B/pression"),           String(pression).c_str(), true);
#endif
#ifdef SHT_30
      if (humidite > 0)    client.publish(strcat (client_mqtt , "/SHT30/humidite"),            String(humidite).c_str(), true);
      if (temperatre > 0)  client.publish(strcat (client_mqtt , "/SHT30/temperature"),         String(temperatre).c_str(), true);
#endif
#ifdef BH_1750
      if (lumiere > 0)     client.publish(strcat (client_mqtt , "/BH1750/lumiere"),            String(lumiere).c_str(), true);
#endif
#ifdef MQ
      if (gaz1 > 0)        client.publish(strcat (client_mqtt , "/MQ135/gaz"),                 String(gaz1).c_str(), true);
#endif
#ifdef SDS011
      if (pm_2_5 > 0)      client.publish(strcat (client_mqtt , "/SDS011/pm2_5"),              String(pm_2_5).c_str(), true);
      if (pm_10 > 0)       client.publish(strcat (client_mqtt , "/SDS011/pm10"),               String(pm_10).c_str(), true);
#else
      if (pm_1_std > 0)        client.publish(strcat (client_mqtt , "/PMS5003/pm_1_std"),           String(pm_1_std).c_str(), true);
      if (pm_2_5_std > 0)      client.publish(strcat (client_mqtt , "/PMS5003/pm2_5_std"),          String(pm_2_5_std).c_str(), true);
      if (pm_10_std > 0)       client.publish(strcat (client_mqtt , "/PMS5003/pm10_std"),           String(pm_10_std).c_str(), true);
      if (pm_1 > 0)        client.publish(strcat (client_mqtt , "/PMS5003/pm_1"),                   String(pm_1).c_str(), true);
      if (pm_2_5 > 0)      client.publish(strcat (client_mqtt , "/PMS5003/pm2_5"),                  String(pm_2_5).c_str(), true);
      if (pm_10 > 0)       client.publish(strcat (client_mqtt , "/PMS5003/pm10"),                   String(pm_10).c_str(), true);
      if (pm_endessous_0_3 > 0) client.publish(strcat (client_mqtt , "/PMS5003/pm_endessous_0_3"),  String(pm_endessous_0_3).c_str(), true);
      if (pm_endessous_0_5 > 0) client.publish(strcat (client_mqtt , "/PMS5003/pm_endessous_0_5"),  String(pm_endessous_0_5).c_str(), true);
      if (pm_endessous_1 > 0)   client.publish(strcat (client_mqtt , "/PMS5003/pm_endessous_1"),    String(pm_endessous_1).c_str(), true);
      if (pm_endessous_2_5 > 0) client.publish(strcat (client_mqtt , "/PMS5003/pm_endessous_2_5"),  String(pm_endessous_2_5).c_str(), true);
      if (pm_endessous_5 > 0)   client.publish(strcat (client_mqtt , "/PMS5003/pm_endessous_5"),    String(pm_endessous_5).c_str(), true);
      if (pm_endessous_10 > 0)  client.publish(strcat (client_mqtt , "/PMS5003/pm_endessous_10"),   String(pm_endessous_10).c_str(), true);
#endif
#ifdef FFT_ON
      if (moy_fft_125 > 0)    client.publish(strcat (client_mqtt , "/FFT/fft_125"),  String(moy_fft_125).c_str(), true);
      if (moy_fft_250 > 0)    client.publish(strcat (client_mqtt , "/FFT/fft_250"),  String(moy_fft_250).c_str(), true);
      if (moy_fft_500 > 0)    client.publish(strcat (client_mqtt , "/FFT/fft_500"),  String(moy_fft_500).c_str(), true);
      if (moy_fft_1000 > 0)   client.publish(strcat (client_mqtt , "/FFT/fft_1000"), String(moy_fft_1000).c_str(), true);
      if (moy_fft_2000 > 0)   client.publish(strcat (client_mqtt , "/FFT/fft_2000"), String(moy_fft_2000).c_str(), true);
      if (moy_fft_4000 > 0)   client.publish(strcat (client_mqtt , "/FFT/fft_4000"), String(moy_fft_4000).c_str(), true);
      if (moy_fft_8000 > 0)   client.publish(strcat (client_mqtt , "/FFT/fft_8000"), String(moy_fft_8000).c_str(), true);
      if (pic_fft_125 > 0)    client.publish(strcat (client_mqtt , "/FFT/pic_fft_125"),  String(pic_fft_125).c_str(), true);
      if (pic_fft_250 > 0)    client.publish(strcat (client_mqtt , "/FFT/pic_fft_250"),  String(pic_fft_250).c_str(), true);
      if (pic_fft_500 > 0)    client.publish(strcat (client_mqtt , "/FFT/pic_fft_500"),  String(pic_fft_500).c_str(), true);
      if (pic_fft_1000 > 0)   client.publish(strcat (client_mqtt , "/FFT/pic_fft_1000"), String(pic_fft_1000).c_str(), true);
      if (pic_fft_2000 > 0)   client.publish(strcat (client_mqtt , "/FFT/pic_fft_2000"), String(pic_fft_2000).c_str(), true);
      if (pic_fft_4000 > 0)   client.publish(strcat (client_mqtt , "/FFT/pic_fft_4000"), String(pic_fft_4000).c_str(), true);
      if (pic_fft_8000 > 0)   client.publish(strcat (client_mqtt , "/FFT/pic_fft_8000"), String(pic_fft_8000).c_str(), true);
#endif
      client.subscribe(strcat (client_mqtt , "/LED/retour"), [](const String & payload) {
        Serial.println(payload);
        //retour_msg();
      });

      ticker.detach();
      //pms.write(Pmsx003::cmdSleep);
      digitalWrite(PIN_ON, LOW); // OFF sensors
      Serial.print("dodo min :");
      Serial.println((float)minute_dodo);
      for (int i = 0; i < 20; i++)
      {
        digitalWrite(BUILTIN_LED, LOW);
        delay(200);
        digitalWrite(BUILTIN_LED, HIGH);
        delay(200);
      }
      // Connect D0 to RST to wake up
      ESP.deepSleep(minute_dodo * 60 * 1000000);
      delay(minute_dodo * 60);
    }
    Serial.println("");

  }
}
